<template>
  <div>
    <div class="row" ref="loanInfo">
      <amnesty-action v-if="$pdl.isAmnesty" v-on:sign="signInstallment"/>
      <notification v-if="!$pdl.supplementary.installment || $pdl.supplementary.installment.status !== 1"></notification>
      <sign-installment v-if="$pdl.supplementary.installment && $pdl.supplementary.installment.status === 1" ref="signInstallment" top></sign-installment>

      <loan-summary :class="[block_detailing ? 'loan-summary-is-open' : 'loan-summary-is-hide']" @detailing="detailing"></loan-summary>

      <div v-show="!componentToShow">
        <!--<buttons-block v-if="$interface.isMobile"></buttons-block>-->
        <div class="white-block">
          <div class="full-table">
            <div class="loan-header">
              <div class="row top">
                <!--<div class="columns one">-->
                  <!--№-->
                <!--</div>-->
                <div class="columns two">
                  Дата начала
                </div>
                <div class="columns two">
                  {{dateOverText}}
                </div>
                <div class="columns two">
                  Срок займа
                </div>
                <div class="columns three">
                  Сумма к погашению
                </div>
                <div class="columns three">
                  Документы
                </div>
              </div>
              <div v-for="(loan, index) in loans" :key="index" class="loan-info-row">
                <div class="row details">
                  <!--<div class="columns one">-->
                    <!--<span class="adaptive">Займ №:</span> {{ loan.num }}-->
                  <!--</div>-->
                  <div class="columns two">
                    <span class="adaptive">Дата начала:</span> {{ $dayjs(loan.dateFrom).format('DD.MM.YYYY') }}
                  </div>
                  <div class="columns two">
                    <span class="adaptive">Дата окончания:</span>
                    <span :class="[{oldText: haveActiveProlongation && loan.type === 1}, noteOverDate ? 'status-6-overdue' : '']">{{ $dayjs(loan.dateTo).format('DD.MM.YYYY') }}</span>
                    <div v-if="haveActiveProlongation && loan.type === 1">
                      <span class="adaptive">Новая дата окончания:</span>
                      <span :class="[noteOverNewDate ? 'status-6-overdue' : '']">{{ newOverDate }}</span>
                    </div>
                  </div>
                  <div class="columns two">
                    <span class="adaptive">Срок займа:</span> {{ loan.days }} {{$helpers.plural(loan.days, ['день', 'дня',
                    'дней'])}}
                  </div>
                  <div class="columns three">
                    <span class="adaptive">Сумма к погашению</span>
                    {{ loan.sumTotal|currency }} ₽

                  </div>
                  <!-- ячейка документов -->
                  <div class="columns three documents">
                    <div v-tooltip.right-start="tooltips.docs" class="cursor-pointer" style="margin: 0 20px 0 8px;">
                    <SVGIcon xlink="docs-20"

                             :fill="$theme.colors.blue"
                             @click.native="$modal.show('docs-list', {creditId: loan.id})">

                    </SVGIcon>
                    </div>
                    <div v-tooltip.right-start="tooltips.statement" class="cursor-pointer">
                    <SVGIcon xlink="document-new-20"

                             :fill="$theme.colors.blue"
                             @click.native="$modal.show('statements-list', {creditId: loan.id})">
                    </SVGIcon>
                    </div>
                    <button @click="expandLoan(index)" class="button expand">
                      <SVGIcon xlink="collapse-20" :fill="$theme.colors.gray" :rotate="loan.expanded ? 180 : 0"></SVGIcon>
                    </button>

                  </div>
                </div>
                <hr>
                <transition name="fade">
                  <div v-if="loan.expanded" class="padding loan-info">
                    <h3 class="gray-header">Подробная информация</h3>
                    <div class="row">
                      <div class="columns six dotted-line">
                        <span class="left-block">Процентная ставка:</span>
                        <span class="right-block">{{ loan.percent}} %</span>
                      </div>
                      <div class="columns six dotted-line">
                        <span class="left-block">{{loan.type === 8 ? 'Сумма ежемесячного платежа' : 'Неустойка:'}}</span>
                        <span class="right-block">{{loan.type === 8 ? installmentLoanPayment : loan.sumPenalty }} ₽</span>
                      </div>
                    </div>
                    <div class="row">
                      <div class="columns six dotted-line">
                        <span class="left-block">Статус займа:</span>
                        <span class="right-block" :class="[($pdl.status === 6 && $pdl.overdue && !finProtection) ? 'status-6-overdue' : '']">{{ loanOverdue || loanStatusText(loan) }}</span>
                      </div>
                      <div class="columns six dotted-line">
                        <span class="left-block">Способ получения займа:</span>
                        <span class="right-block">{{paySystemImg}}</span>
                        <!--<span class="right-block"><img :src="`/lk/static/img/loan/${paySystemImg}`" alt=""></span>-->
                      </div>
                    </div>
                    <div class="row">
                      <div class="columns six dotted-line">
                        <span class="left-block">Основной долг:</span>
                        <span class="right-block">{{loan.sumLeft|currency}} ₽</span>
                      </div>
                      <div class="columns six dotted-line">
                        <span class="left-block">{{loan.type === 8 ? 'Сумма к погашению:' : 'Сумма к погашению на сегодня:'}}</span>
                        <span class="right-block">{{loan.sumTotal|currency}} ₽</span>
                      </div>
                    </div>
                    <div class="row">
                      <div class="columns six dotted-line">
                        <span class="left-block">Сумма процентов:</span>
                        <span class="right-block">{{ loan.sumPercent|currency}} ₽</span>
                      </div>
                    </div>

                    <div v-if="loan.type === 1 && additionalServices.length">
                      <h1 class="gray-header" style="margin-top: 20px;">
                        ДОПОЛНИТЕЛЬНЫЕ УСЛУГИ
                      </h1>
                      <div class="row">
                        <div class="columns six dotted-line" v-for="service in additionalServices"
                             :key="service.guid">
                          <span class="left-block">{{service.title}}:</span>
                          <span class="right-block"><SVGIcon xlink="check-mark-24" viewBox="0 0 24 24"></SVGIcon></span>
                        </div>
                      </div>
                    </div>
                  </div>

                </transition>
              </div>


            </div>

          </div>
          <div class="mobile-table loan-info padding">
            <div v-for="(loan, index) in loans" :key="index" class="mobile-info-row">
              <h3 class="gray-header" style="color:#000">{{loan|loanTitle}}</h3>
              <div class="mobile-table">
                <div class="row">
                  <div class="columns six docs">
                    <a @click.prevent="$modal.show('docs-list', {creditId: loan.id})" href="#"
                       class="documents">
                      Документы
                    </a>
                    <a @click.prevent="$modal.show('statements-list', {creditId: loan.id})" href="#"
                       class="documents statements">
                      Подать заявление
                    </a>
                  </div>
                </div>

              </div>
              <div class="row">
                <!--<div class="columns six dotted-line">-->
                  <!--<span class="left-block">№ займа</span>-->
                  <!--<span class="right-block">{{loan.num}}</span>-->
                <!--</div>-->
                <div class="columns six dotted-line">
                  <span class="left-block">Дата начала</span>
                  <span class="right-block">{{ $dayjs(loan.dateFrom).format('DD.MM.YYYY') }}</span>
                </div>
              </div>
              <div class="row">
                <div class="columns six dotted-line">
                  <span class="left-block" :class="{oldText: haveActiveProlongation && loan.type === 1}">Дата окончания</span>
                  <span class="right-block" :class="[{oldText: haveActiveProlongation && loan.type === 1}, noteOverDate ? 'status-6-overdue' : '']">{{$dayjs(loan.dateTo).format('DD.MM.YYYY')}}</span>
                </div>
                <div class="columns six dotted-line" v-if="haveActiveProlongation && loan.type === 1">
                  <span class="left-block">Новая дата окончания</span>
                  <span class="right-block" :class="[noteOverNewDate ? 'status-6-overdue' : '']">{{newOverDate}}</span>
                </div>
              </div>
              <div class="row">
                <div class="columns six dotted-line">
                  <span class="left-block">Срок займа</span>
                  <span class="right-block">{{loan.days}} {{$helpers.plural(loan.days, ['день', 'дня', 'дней'])}}</span>
                </div>
                <div class="columns six dotted-line">
                  <span class="left-block">{{loan.type === 8 ? 'Сумма к погашению' : currentWidth}}</span>
                  <span class="right-block">{{ loan.sumTotal|currency }} ₽</span>
                </div>
              </div>
              <transition name="fade">
                <div v-if="loan.expanded">
                  <div class="row">
                    <div class="columns six dotted-line">
                      <span class="left-block">Сумма процентов:</span>
                      <span class="right-block">{{ loan.sumPercent|currency }} ₽</span>
                    </div>
                    <div class="columns six dotted-line">
                      <span class="left-block">Процентная ставка:</span>
                      <span class="right-block">{{ loan.percent}} %</span>
                    </div>
                    <div class="columns six dotted-line">
                      <span class="left-block">{{loan.type === 8 ? 'Сумма ежемесячного платежа' : 'Неустойка:'}}</span>
                      <span class="right-block">{{loan.type === 8 ? installmentLoanPayment: loan.sumPenalty }} ₽</span>
                    </div>
                  </div>
                  <div class="row">
                    <div class="columns six dotted-line">
                      <span class="left-block">Статус займа:</span>
                      <span class="right-block" :class="[($pdl.status === 6 && $pdl.overdue && !finProtection) ? 'status-6-overdue' : '']">{{ loanOverdue || loanStatusText(loan) }}</span>
                    </div>
                    <div class="columns six dotted-line">
                      <span class="left-block">Способ получения займа:</span>
                      <span class="right-block">{{paySystemImg}}</span>
                      <!--<span class="right-block"><img :src="`/lk/static/img/loan/${paySystemImg}`" alt=""></span>-->
                    </div>
                  </div>
                  <div class="row">
                    <div class="columns six dotted-line">
                      <span class="left-block">Основной долг:</span>
                      <span class="right-block">{{loan.sumLeft|currency}} ₽</span>
                    </div>
                  </div>
                  <div v-if="loan.type === 1 && additionalServices.length">
                    <h1 class="gray-header" style="margin-top: 20px;">
                      ДОПОЛНИТЕЛЬНЫЕ УСЛУГИ
                    </h1>
                    <div class="row">
                      <div class="columns six dotted-line" v-for="service in additionalServices"
                           :key="service.guid">
                        <span class="left-block">{{service.title}}:</span>
                        <span class="right-block">
                                    <SVGIcon xlink="check-mark-24" viewBox="0 0 24 24"></SVGIcon>
                                  </span>
                      </div>
                    </div>
                  </div>
                </div>
              </transition>
              <div class="row">
                <div class="columns right" style="margin-bottom:20px;">
                  <a @click="expandLoan(index)" :style="`color: ${$theme.colors.blue}` ">
                    {{loan.expanded ? 'Свернуть' : 'Подробнее'}}
                    <SVGIcon xlink="collapse-20" :fill="$theme.colors.blue" viewBox="0 0 24 24"
                             :rotate="loan.expanded ? 180 : 0" style="position: relative;top: 6px;"/>
                  </a>
                </div>
              </div>

            </div>
          </div>
        </div>


        <graphic-payment v-if="$pdl.type === 8"></graphic-payment>
        <buttons-block @click="buttonBlockHandler" ref="buttonsBlock" :fixed="buttonBlockFixed"></buttons-block>
        <warning-block-message v-if="$pdl.type === 8 && [3,4].includes($pdl.status)" ref="infoBlock"></warning-block-message>

        <signing v-if="$pdl.needToSign" :contract-type="$pdl.needToSign.type" ref="signIn"></signing>

        <amnesty v-if="$pdl.supplementary.amnesty" ref="amnesty"></amnesty>
      </div>
      <div v-show="componentToShow">
        <div ref="dynamicComponent">
          <transition name="fade" @after-enter="focusPayForm">

            <component :sum-to-pay="$payment.totalDebt"
                       :is="componentToShow"
                       @back="scrollingUp">
            </component>

          </transition>
        </div>
      </div>
    </div>

    <docs-list/>
    <statements-list/>
  </div>
</template>

<script>
  import Signing from '@/pages/MyLoan/Signing'
  import Payment from '@/components/Pay/Payment'
  import Repay from '@/components/Pay/Repay'
  import Prolongation from '@/pages/MyLoan/Prolongation'
  import Installment from '@/pages/MyLoan/ActiveLoan/Installment'
  import DocsList from '@/components/Modals/DocsList'
  import SupplementaryNeedToBePayed from '@/pages/MyLoan/ActiveLoan/SupplementaryNeedToBePayed'
  import ButtonsBlock from './ButtonsBlock'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import StatementsList from '@/components/Modals/StatementsList'
  import Notification from '@/pages/MyLoan/Notifications.vue'
  import Amnesty from './Amnesty'
  import WarningBlockMessage from '@/pages/MyLoan/ActiveLoan/WarningBlockMessage'
  import GraphicPayment from '@/components/GraphicPayment'
  import pdl from '@/mixins/pdl'
  import Inn from '@/mixins/Inn'
  import SignInstallment from './Installment/SignInstallment'
  import AmnestyAction from './AmnestyActions/index';
  import SVGIcon from '@/components/SVGIcon';
  import LoanSummary from './LoanSummary';

  let NewPdlMessageDisplayed;

  export default {
    name: 'ActiveLoan',
    provide () {
      return {
        ActiveLoan: this
      }
    },
    mixins: [
      ErrorHandleMixin, pdl, Inn
    ],
    components: {
      StatementsList,
      ButtonsBlock,
      SupplementaryNeedToBePayed,
      Signing,
      Payment,
      Repay,
      Prolongation,
      Installment,
      DocsList,
      Notification,
      Amnesty,
      WarningBlockMessage,
      GraphicPayment,
      SignInstallment,
        AmnestyAction,
        SVGIcon,
        LoanSummary
    },

      data () {
        return  {
            fixedButtonsBlock: false,
            IsDetailDisplayed: false,
            componentToShow: '',
            sumToPay: 0,
            timerId: null,
            loans: [],
            tooltips: {
                docs: {
                    trigger: 'hover',
                    autoHide: true,
                    content: ` <span> Открыть список документов по займу </span>`,
                    delay: {
                        show: 500,
                        hide: 500
                    },
                    classes: 'tooltip-base adaptive-tooltip'
                },
                statement: {
                    trigger: 'hover',
                    autoHide: true,
                    content: ` <span> Подать заявление </span>`,
                    delay: {
                        show: 500,
                        hide: 500
                    },
                    classes: 'tooltip-base adaptive-tooltip'
                }
            },
            block_detailing: false,
            noteOverDate: false,
            noteOverNewDate: false,
        }
      },

    computed: {
		finProtection () {
			return this.$pdl.status === 6 && this.$pdl.supplementary?.finProtection?.status === 'active'
		},
		loanOverdue () {
			if (this.$pdl.status === 6 && this.$pdl.overdue && !this.finProtection) {
				return 'Займ просрочен'
			}
			if (this.$pdl.status === 6 &&
                    !this.$pdl.overdue &&
                    ( this.$pdl.supplementary.loanNewDateEnd &&
                      this.$pdl.supplementary?.finProtection?.activated
                    )
            ) {
				return 'Займ продлен'
			}
			return ''
		},
        additionalServices () {
			if(!Array.isArray(this.$pdl?.additional_services)) return [];
			return this.$pdl.additional_services.filter((service) => {
				return this.$store.state.loan.serviceHistory.find((active) => {
					return active.guid === service.guid && active.is_paid
				})
			})
        },
        buttonBlockFixed () {
          return this.$interface.isMobile && this.fixedButtonsBlock;
        },
        installmentLoanPayment () {
            if(this.$pdl.type === 8) {
                return this.$pdl.schedule[0].amount;
            } else {
                return 0;
            }
        },
      credit () {
        if (this.$pdl.type === 8) {
          return this.$pdl.sumLeft
        } else {
          return this.$pdl.sum
        }
      },
      currentWidth () {
        return this.$interface.viewport === 'mobile' ? 'Сумма к погашению' : 'Сумма к погашению';
      },
      haveActiveProlongation () {
        return [3, 4, 5].includes(this.$pdl.supplementary.prolongation?.status)
      },
      dateOverText () {
        // Новая дата окончания, Дата окончания
        return this.haveActiveProlongation ?  'Новая дата окончания' : 'Дата окончания'
      },
      newOverDate () {
        return this.$dayjs(this.$pdl.supplementary.loanNewDateEnd).format('DD.MM.YYYY')
      },
      detailsButtonText () {
        return this.IsDetailDisplayed ? 'Свернуть' : 'Подробнее'
      },
      unpaidDop () {
        return this.$store.getters.getUnpaidDop
      },
      paySystemImg () {
        // return getImgFilename(this.$pdl.paySystem, this.$pdl.bankAccount)
        switch (this.$pdl.paySystem)  {
          case 1: return 'Карта';
          case 3: return 'Яндекс кошелёк';
          case 5: return 'Наличные';
          case 6: return 'QIWI Wallet';
          default: return ''
        }
      },
      typeAmount () {
        return this.$pdl.type === 8 ? this.$pdl.sumLeft : this.$pdl.sum
      }
    },

      watch: {
          '$pdl.status' () {
              this.$helpers.scroll(this.$refs.dynamicComponent.$el);
          },
          componentToShow () {
              console.log('ActiveLoan.index::watch', `componentToShow change`, this.componentToShow);
          }

      },

      filters: {
        loanTitle (loan) {
          switch(loan.type) {
              case 1: return 'Микрозайм';
              case 3: return 'Доп.услуги';
              case 8: return 'Рассрочка';
              default: return 'Займ';
          }
        }
      },
    created () {
        this.$events.$on('ACTIVE_LOAN_PAY', ({ type, amount }) => {
            console.log('MyLoan.index.event::ACTIVE_LOAN_PAY', {type, amount})
            this.$store.commit('SET_PAYMENT', {
                type,
                amount
            });
            this.componentToShow = Payment;
            this.$nextTick(() => {
                this.$helpers.scroll(this.$refs.dynamicComponent);
            });
        });

		this.$events.$on('myloan.begin', () => {
			this.componentToShow = ''
		});

		this.$events.$on('myloan.reset', () => {
            console.log('event::myloan.reset')
            Object.assign(this.$data, this.$options.data());
            this.$nextTick(() => {
                this.init();
            });
        });

        this.$events.$on('myloan.update.payment', () => {
           this.updateSum();
        });

        this.$events.$on('signProlongation', () => {
            this.signProlongation();
        });

        this.$events.$on('payPDL', () => {
          this.buttonBlockHandler('repay');
          this.$nextTick(() => {
            this.$helpers.focus(this.$refs.dynamicComponent.$el);
          })
        })

        this.init();

        window.requestAnimationFrame(this.onScroll);
    },
    mounted () {
      if (this.$pdl.status < 6) {
        this.checkLoanStatus()
      }

      if (this.$pdl.type === 8) {
        const date1 = this.$dayjs(this.$pdl.dateFrom);
        const date2 = this.$dayjs(this.$pdl.dateTo);
        const countMonth = date2.diff(date1, 'month');
        this.$store.dispatch('GET_GRAPHIC_INSTALLMENT', [this.$pdl.sumLeft, countMonth, this.$dayjs(this.$pdl.dateFrom).format('YYYY-MM-DD')])
      }
      this.$events.$on('hidePaymentForm', () => {
        this.componentToShow  = '';
      });

      // this.$nextTick(() => {
      //     this.onScroll();
      // });
      /**
       * Механизм проверки даты окончания займа и его напоминание
       * в случае, если основная дата просрочена или сегодня последний день и займ не был продлен
       * noteOverDate - ставим свойство TRUE
       * в случае, если займ продлен, но новая дата окончания еще не закончила или не сегодня
       * noteOverDate - ставим по дефолту FALSE
       * в случае, если и новая дата продления просрочена или сегодня проследний день
       * noteOverNewDate - ставим свойство TRUE
       * во всех остальных случаях у noteOverDate и noteOverNewDate ставим по дефолту FALSE**/
      let currentDay = this.$dayjs(new Date()).format('YYYY.MM.DD'), // текущая дата
          dateOver = this.$dayjs(this.$pdl.dateTo).format('YYYY.MM.DD'), // основная дата окончания займа
          newDateOver = this.$pdl.supplementary.loanNewDateEnd ? this.$dayjs(this.$pdl.supplementary.loanNewDateEnd).format('YYYY.MM.DD') : null; // было ли продленно время?!
      if (currentDay >= dateOver && !this.finProtection) { // дата окончания просрочена?
          if (newDateOver !== null) { // в случае, если да, смотрим, есть ли продление займа
              if (currentDay >= newDateOver) {
				  this.noteOverNewDate = true; // продленный займ был просрочен
              } else {
				  this.noteOverNewDate = false // все в порядке, займ продлен и время еще есть
              }
          } else {
			  this.noteOverDate = true // займ просрочен и не был продлен
          }
      } else {
		  this.noteOverDate = false // все в порядке
      }


        // Уточняем тип допника
        const supplementary = ['installment', 'amnesty', 'prolongation'].find(key => this.$pdl.supplementary[key]);


        /**
         * Ручка при автологине на проверку оплаты
         */

        switch (this.$auth.additionalFields?.action) {
            case 'pay':
                this.payPDL();
                break;
            case 'payProlongation':
                switch (supplementary) {
                    case 'installment':
                        this.payInstallmentDeposit();
                        break;
                    case 'amnesty':
                        this.payAmnesty();
                        break;
                    case 'prolongation':
                        this.payProlongationDeposit();
                        break;
                    default:
                        break;
                }
        }

        console.log('Тип допника:', supplementary);

        /**
         * Ручка ддя проверки, если у клиента не подписанный займ
         */

        if (this.$auth?.additionalFields?.code && supplementary && this.$pdl.status === 6) {
            switch (supplementary) {
                case 'installment':
                    this.signInstallment();
                    break;
                case 'amnesty':
                    this.signAmnesty();
                    break;
                case 'prolongation':
                    this.signProlongation();
                    break;
                default:
                    break;
            }
        }
    },

    beforeDestroy () {
      clearInterval(this.timerId);
      clearTimeout(this.recountTimeout);
    },
    async beforeCreate () {
      // await this.$store.commit('LOAN_ID', this.$store.getters.getActiveLoanPdl)
    },
    methods: {

    	loanStatusText(loan) {
    		if(this.finProtection) {
    			return 'Займ выдан'
            }

    		return loan.statusText;
        },

        detailing (status) {
			this.block_detailing = status
        },
        init () {
            if (this.$store.getters.ActiveLoanAction) {
                if (typeof this[this.$store.getters.ActiveLoanAction] === "function") {
                    this[this.$store.getters.ActiveLoanAction]();
                    this.$store.commit('SET_ACTIVE_LOAN_ACTION', '');
                }
            }


            if(this.$pdl && this.$pdl.type === 8 && !this.$pdl.status) {
                this.$store.dispatch('GET_GRAPHIC_INSTALLMENT');
            }

            if (this.$pdl.id) {
                this.$pdl.expanded = false;
                this.loans.push(this.$pdl);
            }

            if (this.$posServices?.id) {
                this.$posServices.expanded = false;
                this.loans.push(this.$posServices);
            }
        },
        onScroll () {

            if (!this.$interface.isMobile) return;
            if (!this.$refs?.buttonsBlock?.$el) return;


            /** @type HTMLElement **/
            const el = this.$refs.loanInfo;
            /** @type HTMLElement **/
            const bel = this.$refs.buttonsBlock.$el;
            const { height, top } = el.getBoundingClientRect();
            const bheight = bel.getBoundingClientRect().height;
            const position = (screen.height - height - top - (bheight - (this.fixedButtonsBlock ? -bheight  : 45)));
            this.fixedButtonsBlock = position <= 0;
            const chat = document.querySelector('.sender-connect.bottom-right');

            if(this.fixedButtonsBlock && chat && !this.componentToShow) {
                chat.style.setProperty("bottom", "84px", "important")

            } else if(chat){
                chat.style.bottom = '';
            }

            window.requestAnimationFrame(this.onScroll)

        },

        updateSum (data) {
            const pdl = {...this.$pdl};
            this.$store.dispatch('GET_LOAN_PDL').then(() => {
                if(this.$pdl?.id) {
                    if(this.$pdl.status === pdl.status &&
                        this.$pdl.sumLeft === pdl.sumLeft &&
                        this.$pdl.sumTotal === pdl.sumTotal) {
                        setTimeout(this.updateSum, 10000);

                    } else {
                        const promises = [];
                        promises.push(this.$store.dispatch('GET_LOAN_POS'));
                        this.$store.commit('AJAX_LOADING', true)
                        Promise.all(promises).finally(() => {
                            this.$store.commit('AJAX_LOADING', false);
                        });
                    }
                } else {
                      this.$backend.log({
                          action: 'pay',
                          state: 3,
                          timeStart: new Date().getTime(),
                          meta: {
                              user_id: this.$user.id,
                              loan_id: pdl?.id,
                              loan_payed: 1,
                          },
                      }, false);
                }
            }).catch((e) => {

            });

        },

        expandLoan (index) {
            this.$set(this.loans, index, {...this.loans[index], expanded: !this.loans[index].expanded});
            this.$nextTick(() => {
                this.onScroll();

            })
        },
        scrollToSignForm () {
            console.log('scrollToSignForm');
            this.$nextTick(() => {
                console.log(this.$refs.signIn);
                this.$helpers.scroll(this.$refs.signIn.$el);
            })
        },
      checkLoanStatus () {
        if (this.$auth.isAuth) {

          if (this.$loanType === 8 && this.$pdl && this.$pdl.type === 8 && this.$pdl.status < 3) {
            if (!this.$user.snilsOrInn || String(this.$user.snilsOrInn).length !== 12) {
              this.sendInnCheck();
            }
          }

          this.$store.dispatch('GET_LOAN_PDL').then(() => {
            if (!this.$pdl.id) {
              const promises = [];
              promises.push(this.$methods.user.getUserData());
              promises.push(this.$methods.loan.getLoans());
              this.$store.commit('AJAX_LOADING', true)
              Promise.all(promises).finally(() => {
                this.$store.commit('AJAX_LOADING', false);
              })
            } else if (this.$pdl.status >= 2) {
              console.log('Check pdl data is', this.$pdl);
              if (this.$pdl.status < 6) {
                setTimeout(this.checkLoanStatus, 10000);

                if (this.$pdl.status === 3 && !NewPdlMessageDisplayed) {
                  setTimeout(() => {
                    if (this.$refs.signIn) {
                      switch(this.$pdl.type) {
                        case 1:
                          this.$helpers.scroll(this.$refs.signIn.$el);
                          break;
                        case 8:
                          this.$helpers.scroll(this.$refs.infoBlock.$el);
                          break;
                      }
                    }

                    if(!NewPdlMessageDisplayed) {
                      NewPdlMessageDisplayed = true;
                      this.$toastr.success(`Вам одобрен займ на сумму ${this.typeAmount} рублей. Подпишите договор кодом из SMS.`, 'Займ одобрен!');
                    }
                  }, 1000);
                }
              } else  {
                /**
                 * если статус займа больше 5, то это значит что он либо выдан, либо отказ.
                 * поэтому надо надо перезапросить профиль пользователя, в том числе, чтобы получить
                 * измененные поля (emailConfimred на данный момент)
                 */
                this.AJAX_LOADING(true);
                const promises = [];
                promises.push(this.$methods.user.getUserData());
                promises.push(this.$methods.loan.getLoans());
                Promise.all(promises).finally(() => {
                  this.AJAX_LOADING(false);
                });

              }
            } else {
              setTimeout(this.checkLoanStatus, 10000);
            }
          }).catch((e) => {
            console.warn('Loan status check error', e);
            setTimeout(this.checkLoanStatus, 10000);
          })
        }
      },

        payInstallmentDeposit() {
            let amount = this.$pdl?.supplementary?.installment?.depositAmount;
            if (this.$posServices) {
                amount += this.$posServices.sumLeft;
            }
            console.log('deposit amount', amount);
            this.componentToShow = Payment;
            this.$store.commit('SET_PAYMENT', {
                type: 'installment_deposit',
                amount
            });


            this.$nextTick(() => {
                if (this.$refs.dynamicComponent instanceof HTMLElement) {
                    this.$helpers.scroll(this.$refs.dynamicComponent);
                } else {
                    this.$helpers.scroll(this.$refs.dynamicComponent?.$el);
                }
            });
        },

      scrollingUp () {
    	  console.log('ActiveLoan::index.scrollingUp()');
        this.componentToShow = '';
        this.$nextTick(() => this.$helpers.scroll(this.$el));
      },
        payAmnesty () {
            let amount = parseFloat(this.$pdl.supplementary?.amnesty?.depositAmount);
            if (this.$posServices) {
                amount += parseFloat(this.$posServices?.sumLeft);
            }
            this.$store.commit('SET_PAYMENT', {
                type: 'amnesty_deposit',
                amount
            });

            console.log('payamnesty')
            this.$nextTick(() => {
                if ( this.$refs.amnesty instanceof HTMLElement) {
                    this.$helpers.scroll(this.$refs.amnesty);
                } else {
                    this.$helpers.scroll(this.$refs.amnesty?.$el);
                }
            });
        },

      signInstallment () {
        console.log('%cAction: signInstallment', 'color: blue;font-weight: bold;');
        // this.componentToShow = Installment;
        this.$nextTick(() => {
        	if (!this.$auth.additionalFields?.code && this.$pdl.supplementary.installment.status === 1) {
				this.$helpers.scroll(this.$refs.signInstallment.$el).then(() => {
					this.$refs.signInstallment.$emit('focus');
				});
        	}
        });

      },

      payPDL () {

          if(this.$pdl.supplementary?.amnesty?.status === 1) {
              this.$toastr.warning('Вы должны принять и подписать доп.соглашение', 'Необходимо подписать документы');
              this.$refs.amnesty.$emit('focus');
              return;
          }

        if(this.$pdl.type === 8) {
          let amount;
          if (this.$pdl.supplementary.prolongation && this.$pdl.supplementary.prolongation !== null && this.$pdl.supplementary.prolongation.status === 1) {
            amount = this.$pdl.supplementary.prolongation.depositAmount
          } else {
            amount = this.$store.getters.$graphicInstallment[0].amount
          }
          this.$store.commit('SET_PAYMENT', {
            type: 'installment_loan',
            amount: amount
          })
        } else {
          this.$store.commit('SET_PAYMENT', {
            type: 'PDL',
            amount: parseFloat(this.$payment.totalDebt)
          });
        }

        this.componentToShow = Payment;
        this.$nextTick(() => {
			if (!this.$auth.additionalFields?.action) {
				this.$helpers.scroll(this.$refs.dynamicComponent);
			}
        })

      },

      prolongationCreate () {
        this.componentToShow = Prolongation;
        this.$nextTick(() => {
          this.$helpers.scroll(this.$refs.dynamicComponent);
        });
      },

      focusPayForm () {
        console.log('focusPayForm', this.$pay);
        if (this.$pay.paymentType === 'prolongation_deposit') {
          this.$helpers.scroll(this.$refs.dynamicComponent);
        }
      },

      payProlongationDeposit () {
        console.log('%cAction: payProlongationDeposit', 'color: blue;font-weight: bold;');
        this.componentToShow = Payment;
        this.$store.commit('SET_PAYMENT', {
          type: 'prolongation_deposit',
          amount: this.$payment.prolongationDeposit
        });

        this.$nextTick(() => {
        	if (!this.$auth.additionalFields?.action) {
				this.$helpers.scroll(this.$refs.dynamicComponent);
        	}
        });
      },

      signProlongation () {
        this.componentToShow = Prolongation;
        this.$nextTick(() => {
        	if (!this.$auth.additionalFields?.code  && this.$pdl.supplementary.prolongation.status === 1) {
				this.$helpers.scroll(this.$refs.dynamicComponent);
        	}
        });
      },

      openInstallment () {
        this.componentToShow = Installment;
        this.$nextTick(() => {
          this.$helpers.scroll(this.$refs.dynamicComponent);
        });
      },

      signAmnesty () {
        this.$refs.amnesty.$emit('focus');
      },

      async buttonBlockHandler (event) {
        switch (event) {
          case 'prolongation_deposit':
            this.payProlongationDeposit();
            break;

          case 'repay':
            this.componentToShow = Repay
            break
          case 'pay':
            console.log('pay')
            // если нет суммы платежа, то берем ее из суммы задолженности по всему текущему pdl
            if (!this.$store.getters.getPaymentAmount) {
              this.$store.commit('SET_PAYMENT', {
                type: 'repay',
                amount: this.$pdl.sumTotal
              });
            }
            this.componentToShow = Payment;
            break
          case 'installment':
            this.componentToShow = Installment
            this.$store.commit('SET_PAYMENT', {
              type: 'installment',
              amount: this.$pdl.supplementary.installment.depositAmount
            });
            break
          case 'prolongation':
            this.componentToShow = Prolongation
            break
        }
      },
      changeAndMove (component) {
        this.sumToPay = this.$store.getters.unpaidDop ? this.$store.getters.unpaidDop.price : ''
        this.componentToShow = component
        this.$refs.dynamicComponent.scrollIntoView({block: 'start', behavior: 'smooth'})
        console.log('SCROLL INTO VIEW')
      }
    }
  }
</script>

<style scoped lang="scss">
  @import "static/css/mixins/main";
  @import "static/css/variables/main";
  @import "static/css/variables/color";

  .loan-summary-is-open {
    /*margin-bottom: 85px;*/
    position: relative;
    bottom: 55px;
    animation-duration: 3s;
  }
  .loan-summary-is-hide {
    animation-duration: 3s;
    position: relative;
    bottom: 0;
  }
  .cursor-pointer {
    cursor: pointer;
  }
  .status-6-overdue {
    color: $redDark !important;
    font-weight: bold !important;
  }
  .documents_icons {
    height: 31px;
    line-height: 31px;
    background: url(/lk/static/img/history/docs.png) no-repeat;
    float:right;
    position: relative;
    top: -7px;
    width:31px;
  }
  .mobile-info-row {
    &:nth-child(even) {
      border-top: 1px solid $border;
      margin-top: 10px;
      padding-top: 30px;
    }
  }
  .docs {
    @include flex(flex, row, wrap);
    justify-content: flex-start;
    a {
      &:first-child {
        margin-right: 30px;
        margin-bottom: 20px;
      }

      &.documents {
        background: none;
        padding:0;
      }
      &.statements {
        background: none;
        padding:0;
      }
    }
    margin-bottom:20px;
    margin-top:-20px;

  }

  @media #{$tablet} {
    .docs {
      justify-content: space-between;
      a {
        @include font(14px);

        &:first-child {
          margin-right: 10px;
          margin-bottom: 0;
        }
      }
    }
    .content-block .loan-history .documents {
      padding-left: 38px;
    }
  }

  @media #{$mobile} {
    .docs {
      a {
        &:first-child {
          margin-right: 10px;
          margin-bottom: 20px;
        }
      }
    }
  }
  .documents {
    display: inline-block;
  }
  .oldText {
    text-decoration: line-through;
  }

  @media all and (max-width: 600px) {
    button[data-test="details"] {
      width:100%;
      padding: 15px;
    }
  }
  @media all and (min-width: 1100px) {
    .row {
      & .columns {
        &:nth-child(odd) {
          margin-left: 0;
        }
      }
    }

    .details-button {
      border: 0 !important;
      background: url(/lk/static/img/loan/modal-down.png) 50% 50% no-repeat !important;
      &.open {
        background: url(/lk/static/img/loan/modal-up.png) 50% 50% no-repeat !important;
      }
    }
  }
</style>
